searchNodes=[{"ref":"GenRMQ.Binding.html","title":"GenRMQ.Binding","type":"module","doc":"This module defines common methods for declaring consumer bindings and exchanges."},{"ref":"GenRMQ.Binding.html#t:exchange/0","title":"GenRMQ.Binding.exchange/0","type":"type","doc":""},{"ref":"GenRMQ.Binding.html#t:exchange_kind/0","title":"GenRMQ.Binding.exchange_kind/0","type":"type","doc":""},{"ref":"GenRMQ.Consumer.html","title":"GenRMQ.Consumer","type":"behaviour","doc":"A behaviour module for implementing the RabbitMQ consumer. It will: setup RabbitMQ connection / channel and keep them in a state create (if does not exist) a queue and bind it to an exchange create deadletter queue and exchange handle reconnections call handle_message callback on every message delivery"},{"ref":"GenRMQ.Consumer.html#ack/1","title":"GenRMQ.Consumer.ack/1","type":"function","doc":"Acknowledges given message message - GenRMQ.Message struct"},{"ref":"GenRMQ.Consumer.html#child_spec/1","title":"GenRMQ.Consumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"GenRMQ.Consumer.html#c:consumer_tag/0","title":"GenRMQ.Consumer.consumer_tag/0","type":"callback","doc":"Invoked to provide consumer tag Examples: def consumer_tag() do &quot;hostname-app-version-consumer&quot; end"},{"ref":"GenRMQ.Consumer.html#c:handle_message/1","title":"GenRMQ.Consumer.handle_message/1","type":"callback","doc":"Invoked on message delivery message - GenRMQ.Message struct Examples: def handle_message(message) do # Do something with message and acknowledge it GenRMQ.Consumer.ack(message) end"},{"ref":"GenRMQ.Consumer.html#c:init/0","title":"GenRMQ.Consumer.init/0","type":"callback","doc":"Invoked to provide consumer configuration Return values Mandatory: uri - RabbitMQ uri queue - the name of the queue to consume. If it does not exist, it will be created. exchange - Name or {type, name} of the exchange to which queue should be bound. If it does not exist, it will be created. For valid exchange types see GenRMQ.Binding. routing_key - queue binding key, can also be a list. prefetch_count - limit the number of unacknowledged messages. Optional: queue_ttl - controls for how long a queue can be unused before it is automatically deleted. Unused means the queue has no consumers, the queue has not been redeclared, and basic.get has not been invoked for a duration of at least the expiration period queue_max_priority - defines if a declared queue should be a priority queue. Should be set to a value from 1..255 range. If it is greater than 255, queue max priority will be set to 255. Values between 1 and 10 are recommened. concurrency - defines if handle_message callback is called in seperate process using spawn function. By default concurrency is enabled. To disable, set it to false retry_delay_function - custom retry delay function. Called when the connection to the broker cannot be established. Receives the connection attempt as an argument (&gt;= 1) and is expected to wait for some time. With this callback you can for example do exponential backoff. The default implementation is a linear delay starting with 1 second step. reconnect - defines if consumer should reconnect on connection termination. By default reconnection is enabled. deadletter - defines if consumer should setup deadletter exchange and queue. deadletter_queue - defines name of the deadletter queue (Default: Same as queue name suffixed by _error). deadletter_exchange - defines name of the deadletter exchange (Default: Same as exchange name suffixed by .deadletter). deadletter_routing_key - defines name of the deadletter routing key (Default: #). Examples: def init() do [ queue: &quot;gen_rmq_in_queue&quot;, exchange: &quot;gen_rmq_exchange&quot;, routing_key: &quot;#&quot;, prefetch_count: &quot;10&quot;, uri: &quot;amqp://guest:guest@localhost:5672&quot;, concurrency: true, queue_ttl: 5000, retry_delay_function: fn attempt -&gt; :timer.sleep(1000 * attempt) end, reconnect: true, deadletter: true, deadletter_queue: &quot;gen_rmq_in_queue_error&quot;, deadletter_exchange: &quot;gen_rmq_exchange.deadletter&quot;, deadletter_routing_key: &quot;#&quot;, queue_max_priority: 10 ] end"},{"ref":"GenRMQ.Consumer.html#reject/2","title":"GenRMQ.Consumer.reject/2","type":"function","doc":"Requeues / rejects given message message - GenRMQ.Message struct requeue - indicates if message should be requeued"},{"ref":"GenRMQ.Consumer.html#start_link/2","title":"GenRMQ.Consumer.start_link/2","type":"function","doc":"Starts GenRMQ.Consumer process with given callback module linked to the current process module - callback module implementing GenRMQ.Consumer behaviour Options :name - used for name registration Return values If the consumer is successfully created and initialized, this function returns {:ok, pid}, where pid is the PID of the consumer. If a process with the specified consumer name already exists, this function returns {:error, {:already_started, pid}} with the PID of that process. Examples: GenRMQ.Consumer.start_link(Consumer, name: :consumer)"},{"ref":"GenRMQ.Consumer.html#stop/2","title":"GenRMQ.Consumer.stop/2","type":"function","doc":"Synchronously stops the consumer with a given reason name - pid or name of the consumer to stop reason - reason of the termination Examples: GenRMQ.Consumer.stop(:consumer, :normal)"},{"ref":"GenRMQ.Message.html","title":"GenRMQ.Message","type":"module","doc":"Struct wrapping details of the consumed message Defines: :attributes - message attributes :payload - message raw payload :state - consumer state"},{"ref":"GenRMQ.Processor.html","title":"GenRMQ.Processor","type":"behaviour","doc":"Defines functions to implement by any AMQP processor"},{"ref":"GenRMQ.Processor.html#c:process/1","title":"GenRMQ.Processor.process/1","type":"callback","doc":""},{"ref":"GenRMQ.Publisher.html","title":"GenRMQ.Publisher","type":"behaviour","doc":"A behaviour module for implementing the RabbitMQ publisher"},{"ref":"GenRMQ.Publisher.html#child_spec/1","title":"GenRMQ.Publisher.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"GenRMQ.Publisher.html#c:init/0","title":"GenRMQ.Publisher.init/0","type":"callback","doc":"Invoked to provide publisher configuration Return values Mandatory: uri - RabbitMQ uri exchange - name or {type, name} of the target exchange. If it does not exist, it will be created. For valid exchange types see GenRMQ.Binding. Optional: app_id - publishing application ID. By default it is :gen_rmq. enable_confirmations - activates publishing confirmations on the channel. Confirmations are disabled by default. max_confirmation_wait_time - maximum time in milliseconds to wait for a confirmation. By default it is 5_000 (5s). Examples: def init() do [ exchange: &quot;gen_rmq_exchange&quot;, uri: &quot;amqp://guest:guest@localhost:5672&quot; app_id: :my_app_id, enable_confirmations: true, max_confirmation_wait_time: 5_000 ] end"},{"ref":"GenRMQ.Publisher.html#publish/4","title":"GenRMQ.Publisher.publish/4","type":"function","doc":"Publishes given message publisher - name or PID of the publisher message - raw payload to deliver routing_key - optional routing key to set for given message metadata - optional metadata to set for given message. Keys that are not allowed in metadata are moved under the `:headers` field. Do not include a `:headers` field here: it will be created automatically with all non-standard keys that you have provided. Examples: GenRMQ.Publisher.publish(TestPublisher, &quot;{&quot;msg&quot;: &quot;hello&quot;})"},{"ref":"GenRMQ.Publisher.html#start_link/2","title":"GenRMQ.Publisher.start_link/2","type":"function","doc":"Starts GenRMQ.Publisher with given callback module linked to the current process module- callback module implementing GenRMQ.Publisher behaviour Options :name - used for name registration Return values If the publisher is successfully created and initialized, this function returns {:ok, pid}, where pid is the PID of the publisher. If a process with the specified publisher name already exists, this function returns {:error, {:already_started, pid}} with the PID of that process. Examples: GenRMQ.Publisher.start_link(TestPublisher, name: :publisher)"},{"ref":"GenRMQ.RabbitCase.html","title":"GenRMQ.RabbitCase","type":"module","doc":"This module defines the setup for tests requiring access to the rabbit mq."},{"ref":"readme.html","title":"GenRMQ","type":"extras","doc":"GenRMQ GenRMQ is a set of behaviours meant to be used to create RabbitMQ consumers and publishers. Internally it is using AMQP elixir RabbitMQ client. The idea is to reduce boilerplate consumer / publisher code, which usually includes: creating connection / channel and keeping it in a state creating and binding queue handling reconnections / consumer cancellations The project currently provides the following functionality: GenRMQ.Consumer - a behaviour for implementing RabbitMQ consumers GenRMQ.Publisher - a behaviour for implementing RabbitMQ publishers GenRMQ.Processor - a behaviour for implementing RabbitMQ message processors GenRMQ.RabbitCase - test utilities for RabbitMQ (example usage)"},{"ref":"readme.html#installation","title":"GenRMQ - Installation","type":"extras","doc":"def deps do [{:gen_rmq, &quot;~&gt; 2.2.0&quot;}] end"},{"ref":"readme.html#migrations","title":"GenRMQ - Migrations","type":"extras","doc":"Please check how to migrate to gen_rmq 1.0.0 from previous versions."},{"ref":"readme.html#examples","title":"GenRMQ - Examples","type":"extras","doc":"More thorough examples for using GenRMQ.Consumer and GenRMQ.Publisher can be found in the examples directory. Consumer defmodule Consumer do @behaviour GenRMQ.Consumer def init() do [ queue: &quot;gen_rmq_in_queue&quot;, exchange: &quot;gen_rmq_exchange&quot;, routing_key: &quot;#&quot;, prefetch_count: &quot;10&quot;, uri: &quot;amqp://guest:guest@localhost:5672&quot;, retry_delay_function: fn attempt -&gt; :timer.sleep(2000 * attempt) end ] end def consumer_tag() do &quot;test_tag&quot; end def handle_message(message) do ... end end GenRMQ.Consumer.start_link(Consumer, name: Consumer) This will result in: durable gen_rmq_exchange.deadletter exchange created or redeclared durable gen_rmq_in_queue_error queue created or redeclared. It will be bound to gen_rmq_exchange.deadletter durable topic gen_rmq_exchange exchange created or redeclared durable gen_rmq_in_queue queue created or redeclared. It will be bound to gen_rmq_exchange exchange and has a deadletter exchange set to gen_rmq_exchange.deadletter every handle_message callback will executed in separate process. This can be disabled by setting concurrency: false in init callback on failed rabbitmq connection it will wait for a bit and then reconnect There are many options to control the consumer setup details, please check the GenRMQ.Consumer.init/0 docs for all available settings. Publisher defmodule Publisher do @behaviour GenRMQ.Publisher def init() do [ exchange: &quot;gen_rmq_exchange&quot;, uri: &quot;amqp://guest:guest@localhost:5672&quot; ] end end GenRMQ.Publisher.start_link(Publisher, name: Publisher) GenRMQ.Publisher.publish(Publisher, Jason.encode!(%{msg: &quot;msg&quot;}))"},{"ref":"readme.html#running-tests","title":"GenRMQ - Running tests","type":"extras","doc":"You need docker-compose installed. $ make test"},{"ref":"readme.html#how-to-contribute","title":"GenRMQ - How to contribute","type":"extras","doc":"We happily accept contributions in the form of Github PRs or in the form of bug reports, comments/suggestions or usage questions by creating a github issue."},{"ref":"readme.html#notes-on-project-maturity","title":"GenRMQ - Notes on project maturity","type":"extras","doc":"This library was developed as a Meltwater internal project starting in January 2018. Over the next two months it has been used in at least three Meltwater production services. Are you using gen_rmq in production? Please let us know, we are curious!"},{"ref":"readme.html#license","title":"GenRMQ - License","type":"extras","doc":"The MIT License (MIT) Copyright (c) 2018 - 2019 Meltwater Inc. http://underthehood.meltwater.com/"}]